node_injections = xlsread('node_injections.xlsx','Tabelle1','A2:AJX10000');
%%
mpc.bus = xlsread('nodes.xls','nodes','A2:K10000');
num_nodes = length(mpc.bus(:,1));
%%
mpc.bus(:,12) = mean(node_injections')'; %generation of uniformly distribution generator outputs
%%

for i = 1:num_nodes
    if mpc.bus(i,2) == 28 % Turkey
    mpc.bus(i,6) = 1;
    elseif mpc.bus(i,2) == 7 % Greece
    mpc.bus(i,6) = 2;
    elseif mpc.bus(i,2) == 26 % Bulgaria
    mpc.bus(i,6) = 3;
    elseif mpc.bus(i,2) == 29 | mpc.bus(i,2) == 31 % Croatia Bosnia
    mpc.bus(i,6) = 4;
    elseif mpc.bus(i,2) == 32 | mpc.bus(i,2) == 30 |  mpc.bus(i,2) == 33 | mpc.bus(i,2) == 38 | mpc.bus(i,2) == 37 % Serbia Montenegro Kosovo Albania Macedonia
    mpc.bus(i,6) = 5;   
    elseif  mpc.bus(i,2) == 27  % Romania
    mpc.bus(i,6) = 6;
    elseif  mpc.bus(i,2) == 1 | mpc.bus(i,2) == 25 % Austria Slovenia
    mpc.bus(i,6) = 7;
    elseif  mpc.bus(i,2) == 19 | mpc.bus(i,2) == 24 % Hungary Slovakia
    mpc.bus(i,6) = 8;
    elseif  mpc.bus(i,2) == 17 %Czech
    mpc.bus(i,6) = 9;
    elseif  mpc.bus(i,2) == 23 %Poland
    mpc.bus(i,6) = 10;
    elseif  mpc.bus(i,2) == 21 | mpc.bus(i,2) == 20 | mpc.bus(i,2) == 18 % Estonia Latvia Lithuania
    mpc.bus(i,6) = 11;
    elseif  mpc.bus(i,2) == 4 % Finland
    mpc.bus(i,6) = 12;
    elseif  mpc.bus(i,2) == 14 %Sweden
    mpc.bus(i,6) = 13;
    elseif  mpc.bus(i,2) == 34 %Norway
    mpc.bus(i,6) = 14;
    elseif  mpc.bus(i,2) == 3 %Denmark
    mpc.bus(i,6) = 15;
    elseif  mpc.bus(i,2) == 6  % Germany
    mpc.bus(i,6) = 16;
    elseif  mpc.bus(i,2) == 10 | mpc.bus(i,2) == 11 | mpc.bus(i,2) == 2  % Benelux
    mpc.bus(i,6) = 17;
     elseif  mpc.bus(i,2) == 5  % France
    mpc.bus(i,6) = 18;
     elseif  mpc.bus(i,2) == 13  % Spain
    mpc.bus(i,6) = 19;
     elseif  mpc.bus(i,2) == 12  % Portugal
    mpc.bus(i,6) = 20;
     elseif  mpc.bus(i,2) == 35  % Switzerland
    mpc.bus(i,6) = 21;
     elseif  mpc.bus(i,2) == 9  % Italy
    mpc.bus(i,6) = 22;
    elseif  mpc.bus(i,2) == 39  % Morocco
    mpc.bus(i,6) = 23;
    elseif  mpc.bus(i,2) == 40  % Algeria
    mpc.bus(i,6) = 24;
    elseif  mpc.bus(i,2) == 41 | mpc.bus(i,2) == 42 % Tunisia Libya
    mpc.bus(i,6) = 25;
     elseif  mpc.bus(i,2) == 15  % UK
    mpc.bus(i,6) = 26;
    elseif  mpc.bus(i,2) == 43  % Egypt
    mpc.bus(i,6) = 27;
    end
end
%%

zone_deviation = zeros(26,1);
node_deviation = zeros(num_nodes,960);
node_av_deviation = zeros(num_nodes,1);
for i = 1:26
    node_IND = find(mpc.bus(:,6) == i);
    num_nodes_zone = length(node_IND);
   
    for k = 1:num_nodes_zone
        for j = 1:960
    node_deviation(node_IND(k),j) =  abs(mpc.bus(node_IND(k),12)-node_injections(node_IND(k),j))/abs(mpc.bus(node_IND(k),12));
        end
    end
  
    zone_deviation(i) = sqrt(sum(sum(node_deviation(node_IND,:)))/num_nodes_zone/960);
end

    
    