

node_injections = xlsread('node_injections.xlsx','Tabelle1','A2:AJX10000'); %load injection data, 960 time steps
num_scenarios = length(node_injections(1,:)); % count number of time steps / scenarios

%  -----  Power Flow Data  -----%%
mpc.bus = xlsread('nodes.xls','nodes','A2:K10000'); % load node data
num_nodes = length(mpc.bus(:,1)); %count number of nodes
mpc.bus(:,12) = mean(node_injections')'; %reference set of injections is average over all time steps
% location_ID   country_ID   country_location_ID_   zone_ID   cluster_ID   slack   X-co
%Y-co   unique_node_ID   reference_injection


% branch data (also including transformers)
mpc.branch = xlsread('lines.xls','lines','A2:S10000'); %load line data
num_lines = length(mpc.branch(:,1)); % count number of lines
% line_ID   from_location_ID   to_location_ID   from_country_ID
% to_country_ID   from_country_location_ID   to_country_location_ID
% status   transformer   voltage   resisitance   reactance   thermal_limit
% number_circuits   length   from_voltage   to_voltage
% from_unique_node_ID   to_unique_node_ID   blank   from_zone   to_zone

